package polyglot.ext.ibex.lr;

import polyglot.ext.ibex.types.*;
import polyglot.util.*;
import java.util.*;

class GLRRule {
    Nonterminal nonterm;
    RhsCase nontermRhs;
    GLRNonterminal lhs;
    List rhs;
    int index;

    GLRRule(Nonterminal nonterm, RhsCase nontermRhs, GLRNonterminal lhs, List rhs, int index) {
        this.nonterm = nonterm;
        this.nontermRhs = nontermRhs;
        this.lhs = lhs;
        this.rhs = rhs;
        this.index = index;
    }

    GLRNonterminal lhs() { return lhs; }
    List rhs() { return rhs; }
    int index() { return index; }
    Action action() { return null; }

    public int encode() {
        return (lhs.index() << 8) | rhs.size();
    }

    public boolean equals(Object o) {
        if (o instanceof GLRRule) {
            GLRRule r = (GLRRule) o;
            return index == r.index;
        }
        return false;
    }

    public int hashCode() {
        return index;
    }

    public String toString() {
        String s = index + ": " + lhs + " ::=";
        for (Iterator i = rhs.iterator(); i.hasNext(); ) {
            GLRSymbol y = (GLRSymbol) i.next();
            s += " " + y;
        }
        return s;
    }
}
