import ibex.runtime.*;

class Expr {
}
class Type {
    String id;
    Type(String id) {
        this.id = id;
    }
    public String toString() {
        return "type(" + id + ")";
    }
}
class Id extends Expr {
    String id;
    Id(String id) {
        this.id = id;
    }
    public String toString() {
        return id;
    }
}
class Plus extends Expr {
    Expr x, y;
    Plus(Expr x, Expr y) {
        this.x = x;
        this.y = y;
    }
    public String toString() {
        return "(" + x + " + " + y + ")";
    }
}
class Times extends Expr {
    Expr x, y;
    Times(Expr x, Expr y) {
        this.x = x;
        this.y = y;
    }
    public String toString() {
        return "(" + x + " * " + y + ")";
    }
}

class Cast extends Expr {
  Type x;
  Expr y;
  Cast(Type x, Expr y) {
        this.x = x;
        this.y = y;
  }

  public String toString() {
        return "((" + x + ")" + y + ")";
  }
}

class Token implements Terminal {
    int sym;
    Token(int sym) { this.sym = sym; }
    public int symbol() { return sym; }
    public String toString() { return "token" + sym; }
}

class IdToken extends Token {
    String value;
    IdToken(int sym, String x) { super(sym); this.value = x; }
    public String toString() { return value; }
}
