package polyglot.ext.j0;

import polyglot.lex.Lexer;
import polyglot.ext.j0.parse.Lexer_c;
import polyglot.ext.j0.parse.Grm;
import polyglot.ext.j0.ast.*;
import polyglot.ext.j0.types.*;

import polyglot.ast.*;
import polyglot.types.*;
import polyglot.util.*;
import polyglot.visit.*;
import polyglot.frontend.*;
import polyglot.main.*;

import java.util.*;
import java.io.*;

/**
 * Extension information for skel extension.
 */
public class ExtensionInfo extends polyglot.ext.jl.ExtensionInfo {
    static {
        // force Topics to load
        Topics t = new Topics();
    }

    public String defaultFileExtension() {
        return "j0";
    }

    public String compilerName() {
        return "j0c";
    }

    public Parser parser(Reader reader, FileSource source, ErrorQueue eq) {
        Lexer lexer = new Lexer_c(reader, source.name(), eq);
        Grm grm = new Grm(lexer, ts, nf, eq, this);
        return new CupParser(grm, source, eq);
    }

    protected NodeFactory createNodeFactory() {
        return new J0NodeFactory_c();
    }

    protected TypeSystem createTypeSystem() {
        return new J0TypeSystem_c();
    }

    public List passes(Job job) {
	getOptions().serialize_type_info = false;
        List l = super.passes(job);

        // TODO: add passes as needed by your compiler


        return l;
    }

}
