package polyglot.ext.j0.ast;

import polyglot.ext.jl.ast.*;
import polyglot.types.*;
import polyglot.ast.*;
import polyglot.util.*;
import polyglot.ext.j0.types.*;
import polyglot.visit.*;

import java.util.*;

public class J0Call_c extends Call_c implements Call {

    private J0TypeSystem jts;

    public J0Call_c(Position pos, Receiver target, String name, List arguments) {
	super(pos, target, name, arguments);
    }

    
    public Node typeCheck(TypeChecker tc) throws SemanticException {
	jts = (J0TypeSystem)tc.typeSystem();
	return super.typeCheck(tc);
    }

    private void prettyPrintSuper(CodeWriter w, PrettyPrinter tr) {
	super.prettyPrint(w, tr);
    }

    /** Write the expression to an output file. */
    public void prettyPrint(CodeWriter w, PrettyPrinter tr) {
	try {
	    MethodInstance mi = jts.findStaticMethod(name(), methodInstance().formalTypes());
	    J0Call_c c = this;
	    if(mi.isSameMethod(methodInstance())) {
		c = (J0Call_c)name(mi.name());
	    }
	    c.prettyPrintSuper(w, tr);
	} catch (Exception e) {
	    super.prettyPrint(w, tr);
	}
    }

}
