package polyglot.ext.polyj.ast;

import polyglot.ast.*;
import polyglot.types.*;
import polyglot.util.*;

import polyglot.ext.jl.ast.*;

import polyglot.ext.polyj.ast.*;
import polyglot.ext.polyj.extension.*;
import polyglot.ext.polyj.types.*;
import polyglot.ext.polyj.util.*;

import java.util.*;

/**
 * Constructs JL AST nodes with PolyJ extensions, as well as PolyJ-specific AST nodes.
 */
public interface PolyJNodeFactory extends NodeFactory {
    public AmbInstOrAccess AmbInstOrAccess(Position pos, Receiver prefix, Receiver param);
    public AmbNameParam AmbNameParam(Position pos, AmbReceiver name);
    public AmbNewArray AmbNewArray(Position pos, TypeNode baseType, Receiver param, List dims);
    public AmbNewArray AmbNewArray(Position pos, TypeNode baseType, Receiver param, List dims, int addDims, ArrayInit init);
    public ExprParam ExprParam(Position pos, Expr expr);
    public InstTypeNode InstTypeNode(Position pos, TypeNode base, List params);
    public ParamNode Param(Position pos, Receiver param);
    public PolyJClassDecl PolyJClassDecl(Position pos, Flags flags, String name, List params, List constraints, TypeNode superClass, List interfaces, ClassBody body);
    public PolyJMethodDecl PolyJMethodDecl(Position pos, Flags flags, TypeNode returnType, String name, List formals, List throwTypes, List constraints, Block body);
    public PolyJConstructorDecl PolyJConstructorDecl(Position pos, Flags flags, String name, List formals, List throwTypes, List constraints, Block body);
    public ClassConstraint ClassConstraint(Position pos, String name, List constraints);
    public MethodConstraint MethodConstraint(Position pos, Flags flags, TypeNode tn, String name, List formals, List exceptions);
    public ConstructorConstraint ConstructorConstraint(Position pos, Flags flags, String name, List formals, List exceptions);
    public TypeParam TypeParam(Position pos, TypeNode typeNode);
}

