package polyglot.ext.polyj.types;

import polyglot.ast.*;
import polyglot.frontend.*;
import polyglot.types.*;
import polyglot.util.*;

import polyglot.ext.polyj.extension.*;

import polyglot.ext.jl.types.*;

import java.util.*;

/**
 * Extends a Context to include the type parameters that are in scope.
 */
public class PolyJContext_c extends Context_c implements PolyJContext {

    public PolyJContext_c(TypeSystem ts) {  
        super(ts);
    }

    public void addParams(Iterator params) {
        if ( params == null)
            throw new InternalCompilerError("Tried to push null params");
        
        while (params.hasNext()) {
            ParamType p = (ParamType)params.next();
            this.addNamed(p);
        }
    }

    public PolyJContext pushParams(Iterator params) {
        PolyJContext c = (PolyJContext) super.pushBlock();
        c.addParams(params);
        return c;
    }
    
    public Context pushClass(ParsedClassType scope, ClassType type) {
        PolyJContext c = (PolyJContext) super.pushClass(scope, type);

        if (scope instanceof PolyJClassType) {
            PolyJClassType pc = (PolyJClassType) scope;
            c.addParams(pc.params().iterator());
        }

        return c;
    }
}
