package polyglot.ext.polyj.types;

import polyglot.ext.polyj.ast.*;

import polyglot.types.*;
import polyglot.util.*;

import java.util.*;

/**
 * The operations in common for all polymorphic types.
 */
public interface PolyTypeOps {
    /**
     * Returns a List of ParamType
     */
    List params();

    /**
     * Returns the type representation of the parameter 
     * with the given name.
     */
    ParamType paramNamed(String name);

    /**
     * Returns true if this is a polymorphic type 
     * that can be instantiated.
     */
    boolean isPolymorphic();

    /**
     * Add a type parameter named paramName.
     */
    void addParam(String paramName);
    
    /**
     * Add the constraint to the type.
     */
    void addConstraint(ClassConstraint c) throws SemanticException;

}
