
package polyglot.ext.polyj.util;

import polyglot.types.*;
import polyglot.ext.polyj.types.*;

public interface WhereBinding {
    
    /**
     * Return the translated name of the constraint.
     */
    String name();
    
    /**
     * Returns the procedure instance for this constraint.
     */
    ProcedureInstance procedureInstance();

    /**
     * Returns the method instance for this constraint is it
     * is a method constraint, or null if it is a
     * constructor constraint.
     */
    MethodInstance methodInstance();

    /**
     * Returns the constructor instance for this constraint is it
     * is a constructor constraint, or null if it is a
     * method constraint.
     */
    ConstructorInstance constructorInstance();

    /** 
     * Returns whether the constraint specifies a constructor.
     */
    boolean isConstructor();

    /** 
     * Returns whether the constraint specifies a method.
     */
    boolean isMethod();

    /** 
     * Return whether this constraint is inherited from a supertype.
     */
    boolean isInherited();
}


